Bug 459023 - Dependency errors in cacti
Dependency errors in cacti
Status: CLOSED CURRENTRELEASE
Product: Red Hat HPC Solution
Classification: Red Hat
Component: cacti (Show other bugs)
5.1
All Linux
medium Severity medium
: ---
: ---
Assigned To: OCS Support
:
: 459029 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-08-13 15:50 EDT by Rafael Garabato
Modified: 2008-09-10 18:39 EDT (History)
7 users (show)

See Also:
Fixed In Version: 5.1rc
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-09-10 18:39:29 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Rafael Garabato 2008-08-13 15:50:37 EDT
Description of problem:
After executing the script for installing the kit:
/opt/kusu/sbin/install-kit-cacti

A dependency error occurs:
Error: Missing Dependency: php-common = 5.1.6-20.el5 is needed by package php-mysql

However, the package is present
[root@redhathpc ~]# yum list | grep php-common
php-common.x86_64                        5.1.6-20.el5_2.1       installed


Version-Release number of selected component (if applicable):
I found this in Red Hat 5.2; package ocs-kit-cacti.noarch 0.8.7-1


How reproducible:
Should be reproducible

Steps to Reproduce:
1. See actual results.
2.
3.
  
Actual results:

[root@redhathpc ~]# /opt/kusu/sbin/install-kit-cacti
Loading "rhnplugin" plugin
rhel-x86_64-server-5      100% |=========================| 1.4 kB    00:00
rhel-x86_64-server-hpc-5- 100% |=========================| 1.2 kB    00:00
kit-cacti-0.1-41.noarch.r 100% |=========================|  25 kB    00:00
cacti-0.8.7b-1.el5.noarch 100% |=========================| 2.0 MB    00:14
component-cacti-0.1-42.no 100% |=========================| 9.7 kB    00:00
component-cacti-monitored 100% |=========================| 3.7 kB    00:00
cacti-cactid-0.8.6i-5.x86 100% |=========================|  53 kB    00:01
rrdtool-1.2.23-3.el5.x86_ 100% |=========================| 465 kB    00:04
Adding kit using kitops...
Added kit cacti-0.1-noarch
Adding kit using repoman...
Kit: cacti, version 0.1, architecture noarch, has been added to repo: rhel5_x86_64.  Remember to refresh with -u
Running repoman...
Refreshing repo: rhel5_x86_64. This may take a while...
Running cfmsync...
Running plugin:  /opt/kusu/lib/plugins/cfmsync/getent-data.sh
Distributing 8 KBytes to all nodes.
Updating installer(s)
Error: Missing Dependency: php-common = 5.1.6-20.el5 is needed by package php-mysql
Error: Missing Dependency: php-common = 5.1.6-20.el5 is needed by package php-snmp
Error: Missing Dependency: php-common = 5.1.6-20.el5 is needed by package php
Error: Missing Dependency: php-common = 5.1.6-20.el5 is needed by package php-pdo
Error: Missing Dependency: php-cli = 5.1.6-20.el5 is needed by package php
Done
Sending to 10.0.0.255
Sending to 10.0.0.255
Sending to 10.0.0.255
Sending to 10.0.0.255
Sending to 10.0.0.255
[root@redhathpc ~]# yum list | grep php-common
php-common.x86_64                        5.1.6-20.el5_2.1       installed


Expected results:


Additional info:
Comment 1 Nils Philippsen 2008-08-14 04:51:35 EDT
This is likely a problem with already installed packages on your system, it seems that you have different versions of php-common and php-mysql installed.

Please verify these packages and post the output:

rpm -V php-common
rpm -V php-mysql
Comment 2 Nils Philippsen 2008-08-14 04:55:48 EDT
I think it went this way: You possibly enabled RHEL beta channels which installed the newer version of php-common. If these are disabled now, yum tries to install the older versions of php-mysql etc. which need an older version of php-common. As yum doesn't downgrade to older versions of packages already installed, it errors out with this conflict. Please verify if this is the case and enable the beta channels again or downgrade php-common manually to resolve.
Comment 3 Nils Philippsen 2008-08-14 04:59:26 EDT
*** Bug 459029 has been marked as a duplicate of this bug. ***
Comment 4 Rafael Garabato 2008-08-14 08:34:07 EDT
(In reply to comment #2)
> I think it went this way: You possibly enabled RHEL beta channels which
> installed the newer version of php-common. If these are disabled now, yum tries
> to install the older versions of php-mysql etc. which need an older version of
> php-common. As yum doesn't downgrade to older versions of packages already
> installed, it errors out with this conflict. Please verify if this is the case
> and enable the beta channels again or downgrade php-common manually to resolve.

Here is the output:

[root@redhathpc ~]# rpm -V php-mysql
package php-mysql is not installed
[root@redhathpc ~]# rpm -V php-common
[root@redhathpc ~]# rpm -qa php-mysql
[root@redhathpc ~]# rpm -qa php-common
php-common-5.1.6-20.el5_2.1
[root@redhathpc ~]#

But the error log said:
Error: Missing Dependency: php-common = 5.1.6-20.el5 is needed by package

Aren't both versions of php-common the same?

Regarding php-mysql, it wasn't installed, but why wasn't that dependency automatically resolved?

Also, I enabled the Red Hat HPC Solution Beta channel only


Subscribed Channels (Alter Channel Subscriptions)

    * Red Hat Enterprise Linux (v. 5 for 64-bit x86_64)
    * Red Hat HPC Solution - Beta (v. 5 for 64-bit x86_64)

If HPC is beta and php-common was installed for the beta channel, shouldn't they match the version?

> Please verify if this is the case
> and enable the beta channels again or downgrade php-common manually to > >resolve.

Is this the final solution? I mean, if someone else have the same problem would that mean that he has to manually downgrade and then install again?
Comment 5 Nils Philippsen 2008-08-14 09:25:16 EDT
(In reply to comment #4)
> (In reply to comment #2)
> > I think it went this way: You possibly enabled RHEL beta channels which
> > installed the newer version of php-common. If these are disabled now, yum tries
> > to install the older versions of php-mysql etc. which need an older version of
> > php-common. As yum doesn't downgrade to older versions of packages already
> > installed, it errors out with this conflict. Please verify if this is the case
> > and enable the beta channels again or downgrade php-common manually to resolve.
> 
> Here is the output:
> 
> [root@redhathpc ~]# rpm -V php-mysql
> package php-mysql is not installed
> [root@redhathpc ~]# rpm -V php-common
> [root@redhathpc ~]# rpm -qa php-mysql
> [root@redhathpc ~]# rpm -qa php-common
> php-common-5.1.6-20.el5_2.1
> [root@redhathpc ~]#
> 
> But the error log said:
> Error: Missing Dependency: php-common = 5.1.6-20.el5 is needed by package
> 
> Aren't both versions of php-common the same?

No. Both php-common and php-mysql are subpackages of the same source package and php-mysql (or other subpackages) require the exact same version-release number.

> Regarding php-mysql, it wasn't installed, but why wasn't that dependency
> automatically resolved?
>
> Also, I enabled the Red Hat HPC Solution Beta channel only
> 
> 
> Subscribed Channels (Alter Channel Subscriptions)
> 
>     * Red Hat Enterprise Linux (v. 5 for 64-bit x86_64)
>     * Red Hat HPC Solution - Beta (v. 5 for 64-bit x86_64)
> 
> If HPC is beta and php-common was installed for the beta channel, shouldn't
> they match the version?

I just looked up the current version of the php packages in the RHEL5 channel and it is 5.1.6-20.el5_2.1 so yum should resolve this properly. It may be that the yum metadata locally on the machine is messed up. Please clean it:

yum clean all

Then check that the version of the php packages is the same or higher than of the php-common package which is installed:

yum list all php-common php-mysql

> > Please verify if this is the case
> > and enable the beta channels again or downgrade php-common manually to > >resolve.
> 
> Is this the final solution? I mean, if someone else have the same problem would
> that mean that he has to manually downgrade and then install again?

My first guess was mistaken, so this advice isn't valid anyway.

Please check if yum resolves the dependencies correctly after you've cleaned up the local metadata as described above.
Comment 6 Rafael Garabato 2008-08-14 10:41:22 EDT
(In reply to comment #5)
> (In reply to comment #4)
> > (In reply to comment #2)

I did the clean all.

[root@redhathpc ~]# yum clean all
Loading "security" plugin
Loading "rhnplugin" plugin
Cleaning up Everything
[root@redhathpc ~]# yum list all php-common php-mysql
Loading "security" plugin
Loading "rhnplugin" plugin
rhel-x86_64-server-5      100% |=========================| 1.4 kB    00:00
kusu-installer-ClusterSto 100% |=========================| 1.3 kB    00:00
primary.xml.gz            100% |=========================| 6.8 kB    00:00
kusu-insta: ################################################## 34/34
kusu-installer-Server     100% |=========================| 1.1 kB    00:00
primary.xml.gz            100% |=========================| 1.0 MB    00:00
kusu-insta: ################################################## 3046/3046
kusu-installer-VT         100% |=========================| 1.3 kB    00:00
primary.xml.gz            100% |=========================| 7.0 kB    00:00
kusu-insta: ################################################## 35/35
rhel-x86_64-server-hpc-5- 100% |=========================| 1.2 kB    00:00
kusu-installer-Cluster    100% |=========================| 1.3 kB    00:00
primary.xml.gz            100% |=========================| 5.9 kB    00:00
kusu-insta: ################################################## 32/32
Installed Packages
php-common.x86_64                        5.1.6-20.el5_2.1       installed
Available Packages
php-mysql.x86_64                         5.1.6-20.el5_2.1       rhel-x86_64-serv
Comment 7 Rafael Garabato 2008-08-14 10:47:26 EDT
Another thing I wanted to separate from the other comment.

I tried the script /opt/kusu/sbin/install-kit-cacti again and it looked like it work, but as the kits were already in the repository I tried to re-test it with the following steps:

1) Remove the cacti components from the groups with ngedit
2) repoman -e --kit cacti -r rhel5_x86_64
3) repoman -u -r rhel5_x86_64
4) kitops -e --kit cacti

After that, I executed the script again but it failed. 

http://10.0.0.1/repos/1000/Server/kit-cacti-0.1-41.noarch.rpm: [Errno 14] HTTP Error 404: Not Found

I removed it from the repository so it shouldn't be looking for it. There is also a yum error I attached below:

[root@redhathpc ~]# /opt/kusu/sbin/install-kit-cacti
Loading "rhnplugin" plugin
rhel-x86_64-server-5      100% |=========================| 1.4 kB    00:00
rhel-x86_64-server-hpc-5- 100% |=========================| 1.2 kB    00:00
http://10.0.0.1/repos/1000/Server/kit-cacti-0.1-41.noarch.rpm: [Errno 14] HTTP Error 404: Not Found
Trying other mirror.
Traceback (most recent call last):
  File "/usr/bin/yumdownloader", line 255, in ?
    util = YumDownloader()
  File "/usr/bin/yumdownloader", line 41, in __init__
    self.main()
  File "/usr/bin/yumdownloader", line 76, in main
    self.downloadPackages(opts)
  File "/usr/bin/yumdownloader", line 206, in downloadPackages
    path = repo.getPackage(download)
  File "/usr/lib/python2.4/site-packages/yum/yumRepo.py", line 652, in getPackage
    cache=cache
  File "/usr/lib/python2.4/site-packages/yum/yumRepo.py", line 635, in _getFile
    raise Errors.NoMoreMirrorsRepoError, errstr
yum.Errors.NoMoreMirrorsRepoError: failure: kit-cacti-0.1-41.noarch.rpm from kusu-installer-Server: [Errno 256] No more mirrors to try.
yumdownloader failed; retrying operation in 5 seconds...
Loading "rhnplugin" plugin
rhel-x86_64-server-5      100% |=========================| 1.4 kB    00:00
rhel-x86_64-server-hpc-5- 100% |=========================| 1.2 kB    00:00
http://10.0.0.1/repos/1000/Server/kit-cacti-0.1-41.noarch.rpm: [Errno 14] HTTP Error 404: Not Found
Trying other mirror.
Traceback (most recent call last):
  File "/usr/bin/yumdownloader", line 255, in ?
    util = YumDownloader()
  File "/usr/bin/yumdownloader", line 41, in __init__
    self.main()
  File "/usr/bin/yumdownloader", line 76, in main
    self.downloadPackages(opts)
  File "/usr/bin/yumdownloader", line 206, in downloadPackages
    path = repo.getPackage(download)
  File "/usr/lib/python2.4/site-packages/yum/yumRepo.py", line 652, in getPackage
    cache=cache
  File "/usr/lib/python2.4/site-packages/yum/yumRepo.py", line 635, in _getFile
    raise Errors.NoMoreMirrorsRepoError, errstr
yum.Errors.NoMoreMirrorsRepoError: failure: kit-cacti-0.1-41.noarch.rpm from kusu-installer-Server: [Errno 256] No more mirrors to try.
yumdownloader failed; retrying operation in 10 seconds...
Loading "rhnplugin" plugin
rhel-x86_64-server-5      100% |=========================| 1.4 kB    00:00
rhel-x86_64-server-hpc-5- 100% |=========================| 1.2 kB    00:00
http://10.0.0.1/repos/1000/Server/kit-cacti-0.1-41.noarch.rpm: [Errno 14] HTTP Error 404: Not Found
Trying other mirror.
Traceback (most recent call last):
  File "/usr/bin/yumdownloader", line 255, in ?
    util = YumDownloader()
  File "/usr/bin/yumdownloader", line 41, in __init__
    self.main()
  File "/usr/bin/yumdownloader", line 76, in main
    self.downloadPackages(opts)
  File "/usr/bin/yumdownloader", line 206, in downloadPackages
    path = repo.getPackage(download)
  File "/usr/lib/python2.4/site-packages/yum/yumRepo.py", line 652, in getPackage
    cache=cache
  File "/usr/lib/python2.4/site-packages/yum/yumRepo.py", line 635, in _getFile
    raise Errors.NoMoreMirrorsRepoError, errstr
yum.Errors.NoMoreMirrorsRepoError: failure: kit-cacti-0.1-41.noarch.rpm from kusu-installer-Server: [Errno 256] No more mirrors to try.
yumdownloader failed; retrying operation in 15 seconds...
Loading "rhnplugin" plugin
rhel-x86_64-server-5      100% |=========================| 1.4 kB    00:00
rhel-x86_64-server-hpc-5- 100% |=========================| 1.2 kB    00:00
http://10.0.0.1/repos/1000/Server/kit-cacti-0.1-41.noarch.rpm: [Errno 14] HTTP Error 404: Not Found
Trying other mirror.
Traceback (most recent call last):
  File "/usr/bin/yumdownloader", line 255, in ?
    util = YumDownloader()
  File "/usr/bin/yumdownloader", line 41, in __init__
    self.main()
  File "/usr/bin/yumdownloader", line 76, in main
    self.downloadPackages(opts)
  File "/usr/bin/yumdownloader", line 206, in downloadPackages
    path = repo.getPackage(download)
  File "/usr/lib/python2.4/site-packages/yum/yumRepo.py", line 652, in getPackage
    cache=cache
  File "/usr/lib/python2.4/site-packages/yum/yumRepo.py", line 635, in _getFile
    raise Errors.NoMoreMirrorsRepoError, errstr
yum.Errors.NoMoreMirrorsRepoError: failure: kit-cacti-0.1-41.noarch.rpm from kusu-installer-Server: [Errno 256] No more mirrors to try.
yumdownloader failed; retrying operation in 20 seconds...
Loading "rhnplugin" plugin
rhel-x86_64-server-5      100% |=========================| 1.4 kB    00:00
rhel-x86_64-server-hpc-5- 100% |=========================| 1.2 kB    00:00
http://10.0.0.1/repos/1000/Server/kit-cacti-0.1-41.noarch.rpm: [Errno 14] HTTP Error 404: Not Found
Trying other mirror.
Traceback (most recent call last):
  File "/usr/bin/yumdownloader", line 255, in ?
    util = YumDownloader()
  File "/usr/bin/yumdownloader", line 41, in __init__
    self.main()
  File "/usr/bin/yumdownloader", line 76, in main
    self.downloadPackages(opts)
  File "/usr/bin/yumdownloader", line 206, in downloadPackages
    path = repo.getPackage(download)
  File "/usr/lib/python2.4/site-packages/yum/yumRepo.py", line 652, in getPackage
    cache=cache
  File "/usr/lib/python2.4/site-packages/yum/yumRepo.py", line 635, in _getFile
    raise Errors.NoMoreMirrorsRepoError, errstr
yum.Errors.NoMoreMirrorsRepoError: failure: kit-cacti-0.1-41.noarch.rpm from kusu-installer-Server: [Errno 256] No more mirrors to try.
yumdownloader failed; retrying operation in 25 seconds...
Unable to download packages for kit.  Do you wish to retry [Y/n]? n
Error downloading packages for kit.  Unable to proceed!
[root@redhathpc ~]# yum list kit-cacti
Loading "security" plugin
Loading "rhnplugin" plugin
rhel-x86_64-server-5      100% |=========================| 1.4 kB    00:00
rhel-x86_64-server-hpc-5- 100% |=========================| 1.2 kB    00:00
Available Packages
kit-cacti.noarch                         0.1-41                 kusu-installer-S
[root@redhathpc ~]# ifconfig
eth0      Link encap:Ethernet  HWaddr 00:15:17:30:D9:FC
          inet addr:10.0.0.1  Bcast:10.0.0.255  Mask:255.255.255.0
          inet6 addr: fe80::215:17ff:fe30:d9fc/64 Scope:Link
          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1
          RX packets:8074 errors:0 dropped:0 overruns:0 frame:0
          TX packets:109 errors:0 dropped:0 overruns:0 carrier:0
          collisions:0 txqueuelen:1000
          RX bytes:1380654 (1.3 MiB)  TX bytes:19060 (18.6 KiB)
          Memory:e2160000-e2180000
Comment 8 Nils Philippsen 2008-08-14 10:50:38 EDT
Everything seems in order regarding php package versions. I can't comment on the issue in comment #7. Platform?
Comment 9 Rafael Garabato 2008-08-14 11:29:18 EDT
(In reply to comment #8)
> Everything seems in order regarding php package versions. I can't comment on
> the issue in comment #7. Platform?

Sorry, the YUM repository error was my bad :(. I am starting to understand how yum works. When I did the yum clean all, the yum list rebuilt the table with the components present in each repository. As the cacti component was in a local repository it prefered that one better that Red Hat Networks repository. That was why it was trying to download it locally.  

I had to do a new yum clean all, to rebuild the database and now I get the first problem again:  

Error: Missing Dependency: php-common = 5.1.6-20.el5 is needed by package php-mysql
Error: Missing Dependency: php-common = 5.1.6-20.el5 is needed by package php-snmp
Error: Missing Dependency: php-common = 5.1.6-20.el5 is needed by package php
Error: Missing Dependency: php-common = 5.1.6-20.el5 is needed by package php-pdo
Error: Missing Dependency: php-cli = 5.1.6-20.el5 is needed by package php
Done
Comment 10 Rafael Garabato 2008-08-15 15:29:04 EDT
I have installed a cluster from scratch and this issue dissapeared.

Were there any changes in the yum databases?

If there were, is there any way I can be notified of this changes?  

A couple of days ago I noticed that Ofed kit dissapeared from the Yum Database, a day later I did Yum update and it appeared again. is this possible?
Comment 11 Mark Black 2008-08-15 16:37:06 EDT
> 1) Remove the cacti components from the groups with ngedit
> 2) repoman -e --kit cacti -r rhel5_x86_64
> 3) repoman -u -r rhel5_x86_64
> 4) kitops -e --kit cacti
>
> After that, I executed the script again but it failed. 
> 
> http://10.0.0.1/repos/1000/Server/kit-cacti-0.1-41.noarch.rpm: [Errno 14] HTTP
> Error 404: Not Found

I think this is a case of needing to clear the yum cache:  yum clean all
The files are removed from the repo, with the repoman command, and the repository is rebuilt, but the cached file containing the list of available packages still has the entry.
Comment 12 Keve Gabbert 2008-08-18 18:50:01 EDT
(In reply to comment #8)
> Everything seems in order regarding php package versions. I can't comment on
> the issue in comment #7. Platform?

Platform is similar to Tylersburg-EP (Supermicro) SDV that Red Hat has.
Comment 13 Mark Black 2008-08-20 15:59:30 EDT
The fix is to remove the cacti-cactid packages from the RH HPC Beta channel
It is obsolete and was superceded by "cacti-spine".

Can someone from RH remove this package.

Thanks
Comment 14 Rafael Garabato 2008-08-20 16:12:50 EDT
The fix is to remove cacti-cactid only?

I believe that it may also consist of updating the cacti kit to include cacti-spine.
Comment 15 Keve Gabbert 2008-08-22 11:28:07 EDT
Ron,  who from Red Hat will handle this?  Please change from "new" to "assigned" and identify person as assigned.
Thanks, Keve
Comment 16 Rafael Garabato 2008-08-28 09:59:59 EDT
Is there any update for this Bug? Will cacti-cactid be removed?
Comment 17 Mark Black 2008-08-28 10:08:40 EDT
We (Platform) hope to provide SRPMs to Red Hat later today to address this and other reported issues.  We have changed the component RPM to require cacti-spine instead, so the cacti-cactid package can stay without any issue
Comment 18 Rafael Garabato 2008-09-03 09:11:32 EDT
Once the new packages are added to the Yum repository, Can anyone from Red Hat update the "Fixed in Version" field? Just to be sure I am using the right package version.
Comment 19 Nils Philippsen 2008-09-03 10:27:42 EDT
I'd like Platform to do this -- they're assigned to the bug and will check that the packages they submitted for building are available via FTP/RHN anyway.
Comment 20 OCS Support 2008-09-10 17:12:55 EDT
I've verified the Cacti kit in the beta channel installs.  The changes are in:
component-cacti-0.1-43
kit-cacti-0.1-42
ocs-kit-cacti-0.8.7-2

Note You need to log in before you can comment on or make changes to this bug.